clear all
clc

% Input Constants
const;

dt= tf/(n-1); 
t(1)=0;    
y(1,:)=[H0 u0];


 % ODE Function
f=@(t,y)[F0/At-y(2)*(Ap/At) y(1)*(g/L)-y(2)^2*(Kf/(Ro*Ap))];


% Simulation
for i = 1:n-1
    % Calculation Time
    t(i+1) = t(i)+dt;
    if i<=3
        %%% Runge-Kutta(IV) Method 
        k1 = dt*f(t(i),y(i,:));
        k2 = dt*f(t(i)+dt/2,y(i,:)+k1/2);
        k3 = dt*f(t(i)+dt/2,y(i,:)+k2/2);
        k4 = dt*f(t(i)+dt,y(i,:)+k3);
        y(i+1,:) = y(i,:)+(k1+2*k2+2*k3+k4)/6;
    elseif i>3
        %%% Adams-Moulton Method 
        % y_predictor by Adam formula
        y_p = y(i,:)+dt/24*(55*f(t(i),y(i,:))-59*f(t(i-1),y(i-1,:))+37*f(t(i-2),y(i-2,:))-9*f(t(i-3),y(i-3,:)));
        % y_corrector by Moulten formula
        y_c =y(i,:)+dt/24*(9*f(t(i+1),y_p)+19*f(t(i),y(i,:))-5*f(t(i-1),y(i-1,:))+f(t(i-2),y(i-2,:)));
        y(i+1,:) = y_c;
    end
end

% Creating Final Vector
h=y(:,1);
u=y(:,2);

 % Ploting Results
subplot(2,1,1)
plot(t,h,'linewidth',2)
title('Head')
xlabel('t(s)')
ylabel('h(m)')
axis tight

subplot(2,1,2)
plot(t,u,'r','linewidth',2)
title('Velocity')
xlabel('t(s)')
ylabel('u(m/s)')
axis tight
