clear all
clc

% Data
A=[6 2 1 2; 1 17 13 2; 9 4 16 1; 3 7 5 16];
b=[1.4;6.3;5.0;4.3];

% Initial Guess
x=[1;1;1;1];

% Constants
n=length(x);
s1=0;
s2=0;
err=1;
k=1;
Tol=1e-6;
kmax=100;

% Solver
while err>Tol && k<kmax
    for i=1:n
        for j=1:n
            if i>j
                s1=s1+A(i,j)*x(j,k+1);
            elseif i<j
                 s2=s2+A(i,j)*x(j,k);
            end
        end                 
        x(i,k+1)=(b(i)-s1-s2)/A(i,i);
        s1=0;
        s2=0;        
    end
    err=max(abs(x(:,k+1)-x(:,k)));
    k=k+1;
end

xf=x(:,end)
