clear all
clc

% Constants;
const;	

% Initial Guess
CAt=CA0*[1 0.5 0.2 0.1];

% Solver
while i<imax
    CA(1)=CA0*v0/(v0+k1*V1*CAt(1));
    CA(2)=(CAt(1)*v0+CAt(3)*v1)/(v0+v1+k2*V2*CAt(2));                 
    CA(3)=(CAt(2)*(v0+v1)+CAt(4)*v2)/(v0+v1+v2+k3*V3*CAt(3));
    CA(4)=(CAt(3)*(v0+v2))/(v1+v2+k4*V4*CAt(4));
    OF=sum(abs(CAt-CA));

    if OF<1e-8
        break
    else
        CAt=CA;
    end
end

% Results
fprintf('\nConcentration of A in Reactor 1 = %6.4f\n',CA(1))
fprintf('Concentration of A in Reactor 2 = %6.4f\n',CA(2))
fprintf('Concentration of A in Reactor 3 = %6.4f\n',CA(3))
fprintf('Concentration of A in Reactor 4 = %6.4f\n\n',CA(4))
