clear all
     clc

% Constats
const;

% Initial Guess
CA=CA0*[1; 0.5; 0.2; 0.1];

% Functions
f=@(CA) [CA0*v0-CA(1)*v0-k1*V1*CA(1)^2;...
            CA(1)*v0-CA(2)*(v0+v1)-k2*V2*CA(2)^2+CA(3)*v1;...
               CA(2)*(v0+v1)-CA(3)*(v0+v1+v2)-k3*V3*CA(3)^2+CA(4)*v2;...
                   CA(3)*(v0+v2)-CA(4)*(v0+v2)-k4*V4*CA(4)^2];

df=@(CA)[-v0-2*k1*V1*CA(1) 0 0 0;...
            v0 -(v0+v1)-2*k2*V2*CA(2) CA(3) 0;...
              0 (v0+v1) -(v0+v1+v2)-2*k3*V3*CA(3) v2;...
                  0  0  (v0+v2) -(v0+v2)-2*k4*V4*CA(4)];             
 

% Solver              
for i=1:imax
    for j=1:length(CA)
        if CA(j)~=0
            dCA(j,1)=CA(j)/100;
        else
            dCA(j,1)=1/100;
        end   
    end
    
    fi=feval(f,CA);
    dfi=feval(df,CA);

    if det(dfi)==0
        gama=dCA;
    else
        gama=inv(dfi)*(-fi);
    end
    CA=CA+gama;

    if max(abs(gama))<1e-10
        break
    end
end

% Results
fprintf('\nConcentration of A in Reactor 1 = %6.4f\n',CA(1))
fprintf('Concentration of A in Reactor 2 = %6.4f\n',CA(2))
fprintf('Concentration of A in Reactor 3 = %6.4f\n',CA(3))
fprintf('Concentration of A in Reactor 4 = %6.4f\n\n',CA(4))
