clear all
clc

% Data
N=11;
n=3;
Pco2=[3.38 2.8 2.1 2.4 3.31 3.29 3.5 1.5 1.9 8.5 5.5];
Pn2=[2.4 1.18 2.1 2.18 2.06 2.11 2.17 1.9 0.9 2 2.5];
Pch4=[17.9 15 13.6 14.7 22 23.6 11 20.4 21 20 19.5];
Qco2=[9.15 8.45 6.70 5.90 7.15 9.35 13.80 4.35 5.15 20.35 14.55];

% Kinetic Function
r=@(k) k(1)*Pco2./(1+k(2)*Pco2+k(3)*Pn2+k(4)*Pch4);

% x,y Definition
x1=Pco2;
x2=Pn2;
x3=Pch4;
y=Pco2./Qco2;

% Creating Matrices
b=[sum(y);sum(y.*x1);sum(y.*x2);sum(y.*x3)];
A=[   N     sum(x1)     sum(x2)     sum(x3);
   sum(x1)  sum(x1.^2)  sum(x2.*x1) sum(x3.*x1);
   sum(x2)  sum(x1.*x2) sum(x2.^2)  sum(x3.*x2);
   sum(x3)  sum(x1.*x3) sum(x2.*x3) sum(x3.^2)];

% Solver
% Gauss-Jordan Elimination by Author
a=gj_elim(A,b);
K=[1/a(1) a(2)/a(1) a(3)/a(1) a(4)/a(1)];

% Guass-Jordan Elimination by Matlab Madule
B2=A;
B2(:,end+1)=b;
D=rref(B2);
a2=D(:,end);
K2=[1/a2(1) a2(2)/a2(1) a2(3)/a2(1) a2(4)/a2(1)];

Qcal=r(K);
R2=1-sum((Qco2-Qcal).^2)/sum((Qco2-mean(Qco2)).^2);

Qcal2=r(K2);
R22=1-sum((Qco2-Qcal2).^2)/sum((Qco2-mean(Qco2)).^2);

