clear all
clc

global etha phi x nx dx

% Constants
const;

% Creating Vectors & Step Sizes & Dimensionless Variable
y=zeros(nt,nr);
r=linspace(0,R,nr);
t=linspace(0,tf,nt);
x=r/R;
tau=t/(R^2/D);
phi=K*R^2/D;
etha=0.5*Kc*R/D;
nx=nr;
dx=dr/R;

% Initial Condition
y0(1:nr-1,1)=Ci/C0;

% Solver
[tau,y2]=ode23s(@pdefun,tau,y0);
y(:,2:nr)=y2;

% Adding Boundary Conditions
y(:,1)=(4*y(:,2)-y(:,3))/3;
y(:,nr)=(4*y(:,nr-1)-y(:,nr-2)+2*etha)/(3+2*etha);

% Creating Final Vectors
C=y*C0;
t=(R^2/D)*tau;

% Plotting results
[rr,tt]=meshgrid(r,t);
surf(rr,tt,C)
xlabel('r(cm)')
ylabel('t(s)')
zlabel('C(mol/m^3)')
figure
plot(r,C,'r')  
xlabel('r(cm)')
ylabel('C(mol/m^3)')
axis tight
