clear all
clc

% Constants
n=4;
h=0.25;
dtetag=zeros(n-1,n-1)-1;
d2tetag=zeros(n-1,n-1);
tetax0=1;
tetaxn=0;
Tol=1e-10;

% Solver
for k=1:100
    for i=1:n-1
        for j=1:n-1
            A(i,j)=(h/2)*(1-(j*h)^2-dtetag(i,j));
            B(i,j)=h^2*d2tetag(i,j);
        end
    end
% Creating Coefficients Matrix
    a=[B(1,1)-8/3 B(1,2)-4 B(1,3)-36/13 B(2,1)-8/3 B(2,2)-4 B(2,3)-36/13 B(3,1)-8/3 B(3,2)-4 B(3,3)-36/13];
    a1=[2/3 1 0 2/3 1 0 2/3 1];
    a1m=[1 9/13 0 1 9/13 0 1 9/13];
    a3=[1-A(1,1) 1-A(1,2) 1-A(1,3) 1-A(2,1) 1-A(2,2) 1-A(2,3)];
    a3m=[1+A(2,1) 1+A(2,2) 1+A(2,3) 1+A(3,1) 1+A(3,2) 1+A(3,3)];
    AA=diag(a)+diag(a1,1)+diag(a3,3)+diag(a1m,-1)+diag(a3m,-3);
    C=-[1+A(1,1) 1+A(1,2) 1+A(1,3) 0 0 0 0 0 0];
    
    BB=AA;
    BB(:,end+1)=C';
    D=rref(BB);
    y=D(:,end);
    l=1;
    for i=1:3
        for j=1:3
            teta(i,j)=y(l);
            l=l+1;
        end
    end
    for i=1:n-1
        if i==1
            dteta(i,:)=(teta(i+1,:)-tetax0)/(2*h);
            d2teta(i,:)=(teta(i+1,:)-2*teta(i,:)+tetax0)/(h^2);            
        elseif i==n-1
            dteta(i,:)=(tetaxn-teta(i-1,:))/(2*h);
            d2teta(i,:)=(tetaxn-2*teta(i,:)+teta(i-1,:))/(h^2);            
        else
            dteta(i,:)=(teta(i+1,:)-teta(i-1,:))/(2*h);
            d2teta(i,:)=(teta(i+1,:)-2*teta(i,:)+teta(i-1,:))/(h^2);
        end            
    end    
% Objective Function    
    OF=sum(sum(abs(dtetag-dteta)));
    if OF<Tol
        break
    end
% Guess Modification    
    dtetag=dteta;
    d2tetag=d2teta;
end

% Creating Final Matrix
tetaf=zeros(n+1,n+1);
tetaf(2:n,2:n)=teta;
tetaf(2:n,1)=(4*teta(:,1)-teta(:,2))/3;
tetaf(2:n,n+1)=(4*teta(:,3)-teta(:,2))/(3+h);
tetaf(1,:)=1;
tetaf(n+1,:)=0;
