clear all
clc

% Constants
alfa=0.1;
beta=0.25;
gama=10;
tm=10;
n=10;
m=5;

% Creating Initial 
dx=1/m;
dt=tm/n;
x=0:dx:1;
x=linspace(0,1,m+1);
t=linspace(0,tm,n+1);
u=zeros(m+1,n+1);

landa=alfa*dt/dx^2;
a=[-(1+2*landa) -(1+2*landa) -(1+2*landa) -(1+2*landa) 3];
a1=[landa-0.5*beta*dt/dx   landa-0.5*beta*dt/dx   landa-0.5*beta*dt/dx   landa-0.5*beta*dt/dx];
a1m=[landa+0.5*beta*dt/dx   landa+0.5*beta*dt/dx   landa+0.5*beta*dt/dx  -4];
a2m=[0 0 1];

un=x;

u(:,1)=un;
u(1,:)=1;

% Solver
for k=1:n
    A=diag(a)+diag(a1,1)+diag(a1m,-1)+diag(a2m,-2);
    C=[-(gama*dt+un(1))-(landa+0.5*beta*dt/dx)  -(gama*dt+un(2))  -(gama*dt+un(3))  -(gama*dt+un(4))  0]';

    B=A;
    B(:,end+1)=C;
    D=rref(B);
    y=D(:,end);

    u(2:m+1,k+1)=y;
    un=u(2:m+1,k+1);    
    
end
[T,X]=meshgrid(t,x);
surf(T,X,u)
xlabel('t')
ylabel('x')
zlabel('u')
