clear all
clc

% Constants
ux0=100;
ut0=0;
alfa=0.1;

% Creating Vector & Step Sizes
dx=0.1;
dt=0.1;
x=0:dx:1;
t=0:dt:1;
m=length(x);
n=length(t);
u=zeros(m-1,n);
uf=zeros(m,n);

% Initial Condition
u(:,1)=ut0;

% Solver
for j=1:n-1 
    for  i=1:m-1   
        if i==1
            A(i,i)=-alfa/dx^2-1/dt-0.5;
            A(i,i+1)=0.5*alfa/dx^2;
            C(i)=(alfa/dx^2-1/dt+0.5)*u(i,j)-(0.5*alfa/dx^2)*ux0-(0.5*alfa/dx^2)*u(i+1,j)-(0.5*alfa/dx^2)*ux0; 
        elseif i==m-1
            A(i,i)=1.5+dx;
            A(i,i-1)=-2;
            A(i,i-2)=0.5;
            C(i)=2*dx-(1.5+dx)*u(i,j)+2*u(i-1,j)-0.5*u(i-2,j);     
        else
            A(i,i)=-alfa/dx^2-1/dt-0.5;
            A(i,i+1)=0.5*alfa/dx^2;
            A(i,i-1)=0.5*alfa/dx^2;
            C(i)=(alfa/dx^2-1/dt+0.5)*u(i,j)-(0.5*alfa/dx^2)*u(i-1,j)-(0.5*alfa/dx^2)*u(i+1,j);            
        end        
    end
    y=inv(A)*C';
    u(:,j+1)=y;
end

% Final Vector
uf(1,:)=ux0;
uf(2:m,:)=u;

% Plotting Result
plot(x,uf(:,2),x,uf(:,end),'--','linewidth',2)
legend('u(x,0.1)','u(x,1)')
xlabel('x')
ylabel('u')
