clear all
clc

% Constants
ux0=100;
ut0=0;
alfa=0.1;

% Creating Vector & Step Sizes
dx=0.1;
dt=0.1;
x=0:dx:1;
t=0:dt:1;
m=length(x);
n=length(t);
u=zeros(m-1,n);
uf=zeros(m,n);
u(:,1)=ut0;

% Solver
for j=1:n-1 
    for  i=1:m-1   
        if i==1
            A(i,i)=-2*alfa/dx^2-1/dt-1;
            A(i,i+1)=alfa/dx^2;
            C(i)=-1/dt*u(i,j)-(alfa/dx^2)*ux0; 
        elseif i==m-1
            A(i,i)=3+2*dx;
            A(i,i-1)=-4;
            A(i,i-2)=1;
            C(i)=2*dx;     
        else
            A(i,i)=-2*alfa/dx^2-1/dt-1;
            A(i,i+1)=alfa/dx^2;
            A(i,i-1)=alfa/dx^2;
            C(i)=-1/dt*u(i,j);            
        end        
    end
    y=inv(A)*C';
    u(:,j+1)=y;
end

% Final Vector
uf(1,:)=ux0;
uf(2:m,:)=u;

% Plotting Result
plot(x,uf(:,2),x,uf(:,end),'--','linewidth',2)
legend('u(x,0.1)','u(x,1)')
xlabel('x')
ylabel('u')
